<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <meta name="author" content="Iker Landajuela">
  <link rel="shortcut icon" href="../../../../favicon.ico">
  
  <title>Routing - Programación con Angular</title>
  <link href='https://fonts.googleapis.com/css?family=Lato:400,700|Roboto+Slab:400,700|Inconsolata:400,700' rel='stylesheet' type='text/css'>

  <link rel="stylesheet" href="../../../../css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../../css/theme_extra.css" type="text/css" />
  <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css">
  
  <script>
    // Current page data
    var mkdocs_page_name = "Routing";
    var mkdocs_page_input_path = "conceptos\\routing\\proyecto-basico-routing\\proyecto-basico-routing.md";
    var mkdocs_page_url = "/angular/conceptos/routing/proyecto-basico-routing/proyecto-basico-routing/";
  </script>
  
  <script src="../../../../js/jquery-2.1.1.min.js" defer></script>
  <script src="../../../../js/modernizr-2.8.3.min.js" defer></script>
  <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
  <script>hljs.initHighlightingOnLoad();</script> 
  
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
      <div class="wy-side-nav-search">
        <a href="../../../.." class="icon icon-home"> Programación con Angular</a>
        <div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
	<ul class="current">
	  
          
            <li class="toctree-l1">
		
    <a class="" href="../../../..">Introducción</a>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Conceptos básicos</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../componentes/componentes/">Componentes</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../data-binding/data-binding/">Binding</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../directivas/directivas/">Directivas</a>
                </li>
                <li class=" current">
                    
    <a class="current" href="./">Routing</a>
    <ul class="subnav">
            
    <li class="toctree-l3"><a href="#sistema-de-enrutado-en-angular">Sistema de enrutado en Angular</a></li>
    

    <li class="toctree-l3"><a href="#creacion-de-una-app-con-enrutado-habilitado">Creación de una app con enrutado habilitado</a></li>
    

    <li class="toctree-l3"><a href="#definiendo-el-menu-de-navegacion">Definiendo el menú de navegación</a></li>
    

    <li class="toctree-l3"><a href="#crear-componentes-adicionales-para-la-navegacion">Crear componentes adicionales para la navegación</a></li>
    

    <li class="toctree-l3"><a href="#crear-la-lista-de-rutas-disponibles">Crear la lista de rutas disponibles</a></li>
    

    <li class="toctree-l3"><a href="#ejecucion">Ejecución</a></li>
    

    <li class="toctree-l3"><a href="#dandole-un-poco-de-estilo-con-bulma">Dándole un poco de estilo con Bulma</a></li>
    

    <li class="toctree-l3"><a href="#codigo-fuente-del-proyecto">Código fuente del proyecto</a></li>
    

    <li class="toctree-l3"><a href="#enlaces-externos">Enlaces externos</a></li>
    

    </ul>
                </li>
                <li class="">
                    
    <a class="" href="../../../http/consumir-servicios-api-rest/consumir-servicios-api-rest/">Consumir servicios REST</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../estilos/instalar-bootstrap/instalar-bootstrap/">Introducción Bootstrap</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Proyectos</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../../intro/getting-started/getting-started/">Mi primera aplicación</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../../intro/flujo-de-una-app/flujo-de-una-app/">Flujo de una aplicación</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../../intro/todo-aplicacion-lista-tareas/todo-aplicacion-lista-tareas/">Aplicación lista de tareas</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../../intro/reddit-clone/reddit-clone/">Tutorial:  Simple Reddit clone</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../../intro/ejercicio-gestion-clientes/ejercicio-gestion-clientes/">Aplicación: Gestión clientes</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../../intro/tour-of-heroes/tour-of-heroes/">Tutorial: Tour of Heroes</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Módulos</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../../modulos/rxjs/rxjs/">Programación reactiva RxJS</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Formularios</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../../ui/forms/basic-form/basic-form/">Formulario básico (Reactive)</a>
                </li>
                <li class="">
                    
    <a class="" href="../../../../ui/forms/basic-form-validation/basic-form-validation/">Validación básica formulario (Reactive)</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Componentes UI</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../../ui/primeng/primeng/">PrimeNG</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <span class="caption-text">Otros</span>
    <ul class="subnav">
                <li class="">
                    
    <a class="" href="../../../../otros/json-server/json-server/">JSON-Server NodeJS</a>
                </li>
    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <a class="" href="../../../../recursos/recursos/">Recursos</a>
	    </li>
          
        </ul>
      </div>
      &nbsp;
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../..">Programación con Angular</a>
      </nav>

      
      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../..">Docs</a> &raquo;</li>
    
      
        
          <li>Conceptos básicos &raquo;</li>
        
      
    
    <li>Routing</li>
    <li class="wy-breadcrumbs-aside">
      
        <a href="https://gitlab.com/soka/angular/edit/master/docs/conceptos/routing/proyecto-basico-routing/proyecto-basico-routing.md"
          class="icon icon-gitlab"
        > Edit on GitLab</a>
      
    </li>
  </ul>
  <hr/>
</div>
          <div role="main">
            <div class="section">
              
                <div class="toc">
<ul>
<li><a href="#sistema-de-enrutado-en-angular">Sistema de enrutado en Angular</a></li>
<li><a href="#creacion-de-una-app-con-enrutado-habilitado">Creación de una app con enrutado habilitado</a></li>
<li><a href="#definiendo-el-menu-de-navegacion">Definiendo el menú de navegación</a></li>
<li><a href="#crear-componentes-adicionales-para-la-navegacion">Crear componentes adicionales para la navegación</a></li>
<li><a href="#crear-la-lista-de-rutas-disponibles">Crear la lista de rutas disponibles</a></li>
<li><a href="#ejecucion">Ejecución</a></li>
<li><a href="#dandole-un-poco-de-estilo-con-bulma">Dándole un poco de estilo con Bulma</a></li>
<li><a href="#codigo-fuente-del-proyecto">Código fuente del proyecto</a></li>
<li><a href="#enlaces-externos">Enlaces externos</a></li>
</ul>
</div>
<h1 id="sistema-de-enrutado-en-angular">Sistema de enrutado en Angular</h1>
<p>En un sitio Web normalmente los enlaces de navegación apuntan a diferentes rutas, cuando pinchamos sobre ellos el servidor Web recibe la petición, carga la nueva página y entrega la página solicitada en la nueva ruta, por ejemplo este artículo pertenece al sitio raíz <a href="https://soka.gitlab.io/angular/">https://soka.gitlab.io/angular/</a>, cuando pinchamos sobre un enlace en el menú lateral como por ejemplo <a href="https://soka.gitlab.io/angular/intro/getting-started/getting-started/">https://soka.gitlab.io/angular/intro/getting-started/getting-started/</a>, el servidor carga la página en una nueva ruta en "/angular/intro/getting-started/getting-started/".</p>
<p>Las Web construidas con <strong>Angular</strong> siguen el concepto SPA (Single Page Application), sólo tenemos una página principal "index.html", todas las vistas asociadas a cada componente se cargan sobre este index.html. Para facilitar la navegación entonces usamos el sistema de enrutado con rutas "virtuales".</p>
<h1 id="creacion-de-una-app-con-enrutado-habilitado">Creación de una app con enrutado habilitado</h1>
<p>La opción de enrutado no está habilitada por defecto cuando creamos un nuevo proyecto, hay que indicar explicitamente que queremos usarla en las opciones de creación del proyecto.</p>
<pre><code class="ps">ng new routing-basics-nav-menu
</code></pre>

<p>Uan vez creado el proyecto en [src/app/app.module.ts] <strong>Angular</strong> importa la clase "AppRoutingModule" del componente donde se configuran las rutas:</p>
<pre><code class="ts">import { BrowserModule } from &quot;@angular/platform-browser&quot;;
import { NgModule } from &quot;@angular/core&quot;;

import { AppRoutingModule } from &quot;./app-routing.module&quot;; // &lt;---- Route
import { AppComponent } from &quot;./app.component&quot;;

@NgModule({
  declarations: [AppComponent],
  imports: [
    BrowserModule,
    AppRoutingModule // &lt;---- Route
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule {}
</code></pre>

<h1 id="definiendo-el-menu-de-navegacion">Definiendo el menú de navegación</h1>
<p>En [src/app/app.component.html] definimos la vista con el menú de navegación con el atributo <a href="https://angular.io/api/router/RouterLink"><code>routerLink</code></a> definimos la ruta de cada opción, los enlaces comienzan por "/" para referirse al raíz.</p>
<pre><code class="ts">&lt;nav&gt;
  &lt;a href=&quot;#&quot; routerLink=&quot;/&quot;&gt;Home&lt;/a&gt; |
  &lt;a href=&quot;#&quot; routerLink=&quot;/contacto&quot;&gt;Contacto&lt;/a&gt; |
&lt;/nav&gt;

&lt;router-outlet&gt;&lt;/router-outlet&gt;
</code></pre>

<p>Más abajo la directiva <code>&lt;router-outlet&gt;</code> inyecta un componente u otro dependiendo de la ruta elegida.</p>
<h1 id="crear-componentes-adicionales-para-la-navegacion">Crear componentes adicionales para la navegación</h1>
<p>Voy a crear el componente "contacto" al que hace referencia el menú.</p>
<pre><code class="ps">ng g c contacto
</code></pre>

<p>He creado un nuevo componente [src/app/contacto/contacto.component.ts]. Usando el mismo sistema he creado un componente "home" con <code>ng g c home</code>.</p>
<h1 id="crear-la-lista-de-rutas-disponibles">Crear la lista de rutas disponibles</h1>
<p>En la cabecera de [src/app/app-routing.module.ts] se importan las clases necesarias:</p>
<pre><code class="ts">import { NgModule } from &quot;@angular/core&quot;;
import { Routes, RouterModule } from &quot;@angular/router&quot;;

import { ContactoComponent } from &quot;./contacto/contacto.component&quot;; // &lt;---
import { HomeComponent } from &quot;./home/home.component&quot;; // &lt;---
</code></pre>

<p>En el cuerpo se declara <code>routes</code> que es un array de objetos de tipo <code>Routes</code>, inicialmente vacío añado al array los componentes que corresponden a cada ruta en el menú.</p>
<pre><code class="ts">const routes: Routes = [
  { path: &quot;&quot;, component: HomeComponent },
  { path: &quot;contacto&quot;, component: ContactoComponent }
];
</code></pre>

<h1 id="ejecucion">Ejecución</h1>
<p>Con estos sencillos pasos ya tenemos en marcha nuestro menú de navegación entre componentes:</p>
<p><img alt="" src="../img/01.PNG" /></p>
<h1 id="dandole-un-poco-de-estilo-con-bulma">Dándole un poco de estilo con Bulma</h1>
<p><img alt="" src="../img/02.PNG" /></p>
<p><a href="https://bulma.io/">Bulma</a> es un <em>framework</em> CSS responsivo y modular para dar estilo a nuestras páginas. Procedemos con la instalación en el raíz del proyecto:</p>
<pre><code class="ps">npm install bulma
</code></pre>

<p>Una vez instalado modifico "angular.json":</p>
<pre><code class="json">            &quot;styles&quot;: [
              &quot;node_modules/bulma/css/bulma.min.css&quot;,
              &quot;src/styles.css&quot;
            ],
</code></pre>

<p>Debemos parar y arrancar la app para que los cambios tengan efecto (<code>ng serve -o</code>).</p>
<p>Uso el <a href="https://bulma.io/documentation/components/menu/">componente menú</a> de Bulma para decorar mi menú:</p>
<pre><code class="ts">&lt;aside class=&quot;menu&quot;&gt;
  &lt;p class=&quot;menu-label&quot;&gt;
    General
  &lt;/p&gt;
  &lt;ul class=&quot;menu-list&quot;&gt;
    &lt;li&gt;&lt;a href=&quot;#&quot; routerLink=&quot;/&quot;&gt;Home&lt;/a&gt;&lt;/li&gt;
    &lt;li&gt;&lt;a href=&quot;#&quot; routerLink=&quot;/contacto&quot;&gt;Contacto&lt;/a&gt;&lt;/li&gt;
  &lt;/ul&gt;
&lt;/aside&gt;

&lt;router-outlet&gt;&lt;/router-outlet&gt;
</code></pre>

<p>Ahora el menú tiene un aspecto más elegante:</p>
<p><img alt="" src="../img/03.PNG" /></p>
<h1 id="codigo-fuente-del-proyecto">Código fuente del proyecto</h1>
<ul>
<li>angular / src / conceptos / routing / <a href="https://gitlab.com/soka/angular/tree/master/src/conceptos/routing/routing-basics-nav-menu">routing-basics-nav-menu</a>.</li>
</ul>
<h1 id="enlaces-externos">Enlaces externos</h1>
<ul>
<li><a href="https://angular.io/api/router/Router">"Router CLASS"</a>: Especificación clase.</li>
<li><a href="https://angular.io/guide/router">"Routing &amp; Navigation - Angular"</a>.</li>
<li><a href="">"Routing - Angular"</a>: Tutorial Tout of heroes.</li>
<li><a href="https://desarrolloweb.com/articulos/introduccion-sistema-routing-angular.html">"Introducción al sistema de Routing en Angular - Desarrolloweb"</a>.</li>
<li><a href="http://respagblog.azurewebsites.net/tutorial-paso-a-paso-de-angular-7-3-routing/">"Tutorial paso a paso de Angular 7 #3: Routing - El blog de respag"</a>.</li>
</ul>
              
            </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../../../http/consumir-servicios-api-rest/consumir-servicios-api-rest/" class="btn btn-neutral float-right" title="Consumir servicios REST">Next <span class="icon icon-circle-arrow-right"></span></a>
      
      
        <a href="../../../directivas/directivas/" class="btn btn-neutral" title="Directivas"><span class="icon icon-circle-arrow-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
    
  </div>

  Built with <a href="http://www.mkdocs.org">MkDocs</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
      
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" style="cursor: pointer">
    <span class="rst-current-version" data-toggle="rst-current-version">
      
          <a href="https://gitlab.com/soka/angular/" class="icon icon-gitlab" style="float: left; color: #fcfcfc"> GitLab</a>
      
      
        <span><a href="../../../directivas/directivas/" style="color: #fcfcfc;">&laquo; Previous</a></span>
      
      
        <span style="margin-left: 15px"><a href="../../../http/consumir-servicios-api-rest/consumir-servicios-api-rest/" style="color: #fcfcfc">Next &raquo;</a></span>
      
    </span>
</div>
    <script>var base_url = '../../../..';</script>
    <script src="../../../../js/theme.js" defer></script>
      <script src="../../../../search/main.js" defer></script>

</body>
</html>
